

class Message:
    """This class is used to describe a CAN message, composed of a CAN id,
    the data length code (DLC), and the data field. All other fields that
    are needed for a valid CAN frame (such as CRC and ACK) are automatically
    generated by the CAN controller hardware."""
    def __init__(self, can_id, data=None, dlc=None):
        self.can_id = can_id
        if data is None:
            self.data = bytearray()
            self.dlc = 0
        else:
            self.data = bytearray(data)

        if dlc is None:
            self.dlc = len(self.data)
        else:
            self.dlc = dlc

        if self.dlc > 8:
            raise Exception("Data count must be lower or equal to 8".format(
                self.dlc))

    def __len__(self):
        return len(self.data)
